package main

import (
	"fmt"

	"codeberg.org/vlbeaudoin/voki/v3"
)

type APIResponse struct {
	voki.MessageResponse
	statusCode int
}

func (R APIResponse) StatusCode() int { return R.statusCode }

func (R *APIResponse) SetStatusCode(code int) error {
	if code <= 0 {
		return fmt.Errorf("Cannot set status code to %d", code)
	}
	R.statusCode = code
	return nil
}

type HealthGETResponse struct {
	APIResponse
}

type MembreGETResponse struct {
	APIResponse
	Data MembreGETResponseData `json:"data"`
}
type MembreGETResponseData struct {
	Membre Membre `json:"membre"`
}

type MembresGETResponse struct {
	APIResponse
	Data MembresGETResponseData `json:"data"`
}

type MembresGETResponseData struct {
	Membres []Membre `json:"membres"`
}

type MembresPOSTResponse struct {
	APIResponse
	Data MembresPOSTResponseData `json:"data"`
}

type MembresPOSTResponseData struct {
	MembresInserted int64 `json:"membres_inserted"`
}

type ProgrammesPOSTResponse struct {
	APIResponse
	Data ProgrammesPOSTResponseData `json:"data"`
}

type ProgrammesPOSTResponseData struct {
	ProgrammesInserted int64 `json:"programmes_inserted"`
}
